<?php
// Establishing database connection
$servername = "localhost"; 
$username = "radovan4";     
$password = "Nacicu73@Evolan!";  
$dbname = "radovan4_assign9donation"; 

// Creating the connection
$conn = new mysqli($servername, $username, $password, $dbname);

// Checking the connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$results = [];

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    
    if (isset($_POST['search_by_name'])) {
        // Search by donor's first name and/or last name
        $fname = isset($_POST['fname']) ? trim($_POST['fname']) : '';
        $lname = isset($_POST['lname']) ? trim($_POST['lname']) : '';

        $sql = "SELECT * FROM donation WHERE 1=1";
        if (!empty($fname)) {
            $sql .= " AND fname LIKE ?";
        }
        if (!empty($lname)) {
            $sql .= " AND lname LIKE ?";
        }

        $stmt = $conn->prepare($sql);

        if (!empty($fname) && !empty($lname)) {
            $fname = "%" . $fname . "%";
            $lname = "%" . $lname . "%";
            $stmt->bind_param("ss", $fname, $lname);
        } elseif (!empty($fname)) {
            $fname = "%" . $fname . "%";
            $stmt->bind_param("s", $fname);
        } elseif (!empty($lname)) {
            $lname = "%" . $lname . "%";
            $stmt->bind_param("s", $lname);
        }

        $stmt->execute();
        $result = $stmt->get_result();
        $results['by_name'] = $result;
        $stmt->close();
    }

    if (isset($_POST['search_by_value'])) {
        // Search by donation value range
        $min_value = isset($_POST['min_value']) ? $_POST['min_value'] : 0;
        $max_value = isset($_POST['max_value']) ? $_POST['max_value'] : PHP_INT_MAX;

        $sql = "SELECT * FROM donation WHERE value BETWEEN ? AND ?";

        $stmt = $conn->prepare($sql);
        $stmt->bind_param("dd", $min_value, $max_value);
        $stmt->execute();
        $result = $stmt->get_result();
        $results['by_value'] = $result;
        $stmt->close();
    }

    if (isset($_POST['search_by_type'])) {
        // Search by donation type
        $donation_type = isset($_POST['donation_type']) ? trim($_POST['donation_type']) : '';

        $sql = "SELECT * FROM donation WHERE donation_type LIKE ?";
        
        $stmt = $conn->prepare($sql);
        $donation_type = "%" . $donation_type . "%";
        $stmt->bind_param("s", $donation_type);
        $stmt->execute();
        $result = $stmt->get_result();
        $results['by_type'] = $result;
        $stmt->close();
    }

    if (isset($_POST['search_by_date'])) {
        // Search by date range
        $start_date = isset($_POST['start_date']) ? $_POST['start_date'] : '';
        $end_date = isset($_POST['end_date']) ? $_POST['end_date'] : '';

        $sql = "SELECT * FROM donation WHERE date BETWEEN ? AND ?";

        $stmt = $conn->prepare($sql);
        $stmt->bind_param("ss", $start_date, $end_date);
        $stmt->execute();
        $result = $stmt->get_result();
        $results['by_date'] = $result;
        $stmt->close();
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Donation Search</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f4f6f9;
            margin: 0;
            padding: 0;
        }
        .container {
            width: 80%;
            margin: 20px auto;
            padding: 20px;
            background-color: #ffffff;
            border-radius: 10px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }
        h1 {
            text-align: center;
            color: #4CAF50;
        }
        h2 {
            color: #333;
        }
        form {
            background-color: #fafafa;
            padding: 20px;
            margin: 20px 0;
            border-radius: 8px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.05);
        }
        label {
            font-weight: bold;
            color: #555;
        }
        input, select {
            width: 100%;
            padding: 10px;
            margin: 10px 0;
            border-radius: 5px;
            border: 1px solid #ccc;
            font-size: 16px;
        }
        input[type="submit"] {
            width: auto;
            background-color: #4CAF50;
            color: white;
            border: none;
            cursor: pointer;
        }
        input[type="submit"]:hover {
            background-color: #45a049;
        }
        .results {
            margin-top: 30px;
            background-color: #e9f7e9;
            padding: 15px;
            border-radius: 5px;
        }
        .results div {
            margin-bottom: 20px;
            padding: 15px;
            background-color: #ffffff;
            border: 1px solid #ddd;
            border-radius: 5px;
        }
        .results div strong {
            display: block;
            margin-bottom: 8px;
            color: #4CAF50;
        }
        .results div p {
            margin: 5px 0;
            color: #555;
        }
    </style>
</head>
<body>

<div class="container">
    <h1>Search Donations</h1>

    <!-- Searching by Name -->
    <h2>Search by Donor's Name</h2>
    <form action="" method="POST">
        <label for="fname">First Name:</label>
        <input type="text" id="fname" name="fname">

        <label for="lname">Last Name:</label>
        <input type="text" id="lname" name="lname">

        <input type="submit" name="search_by_name" value="Search Donations by Name">
    </form>

    <!-- Searching by Value -->
    <h2>Search by Donation Value Range</h2>
    <form action="" method="POST">
        <label for="min_value">Minimum Value:</label>
        <input type="number" id="min_value" name="min_value" step="0.01">

        <label for="max_value">Maximum Value:</label>
        <input type="number" id="max_value" name="max_value" step="0.01">

        <input type="submit" name="search_by_value" value="Search Donations by Value">
    </form>

    <!-- Searching by Donation Type -->
    <h2>Search by Donation Type</h2>
    <form action="" method="POST">
        <label for="donation_type">Donation Type:</label>
        <select id="donation_type" name="donation_type">
            <option value="Cash">Cash</option>
            <option value="Cloth">Cloth</option>
            <option value="Electric">Electric</option>
            <option value="Food">Food</option>
            <option value="Supplies">Supplies</option>
            <option value="Appliances">Appliances</option>
        </select>

        <input type="submit" name="search_by_type" value="Search Donations by Type">
    </form>

    <!-- Searching by Date Range -->
    <h2>Search by Donation Date Range</h2>
    <form action="" method="POST">
        <label for="start_date">Start Date:</label>
        <input type="date" id="start_date" name="start_date">

        <label for="end_date">End Date:</label>
        <input type="date" id="end_date" name="end_date">

        <input type="submit" name="search_by_date" value="Search Donations by Date">
    </form>

    <?php
    // Displaying search results for all queries
    function display_results($result, $search_type) {
        if ($result->num_rows > 0) {
            echo "<div class='results'>";
            echo "<h3>Results for $search_type:</h3>";
            echo "<p>Found " . $result->num_rows . " record(s).</p>";

            while ($row = $result->fetch_assoc()) {
                echo "<div>";
                echo "<strong>Name:</strong> " . $row['fname'] . " " . $row['lname'] . "<br>";
                echo "<strong>Email:</strong> " . $row['email'] . "<br>";
                echo "<strong>Donation Type:</strong> " . $row['donation_type'] . "<br>";
                echo "<strong>Value:</strong> " . $row['value'] . "<br>";
                echo "<strong>Date:</strong> " . $row['date'] . "<br>";
                echo "<strong>Comments:</strong> " . $row['comments'] . "<br>";
                echo "</div><hr>";
            }
            echo "</div>";
        } else {
            echo "<div class='results'><p>No results found for $search_type.</p></div>";
        }
    }

    
    if (isset($results['by_name'])) {
        display_results($results['by_name'], 'Name');
    }

    if (isset($results['by_value'])) {
        display_results($results['by_value'], 'Value Range');
    }

    if (isset($results['by_type'])) {
        display_results($results['by_type'], 'Donation Type');
    }

    if (isset($results['by_date'])) {
        display_results($results['by_date'], 'Date Range');
    }
    ?>

</div>

</body>
</html>

<?php
// Closing connection
$conn->close();
?>
